// PbIniCleanerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PbIniCleaner.h"
#include "PbIniCleanerDlg.h"

#include "Registry.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPbIniCleanerDlg dialog

CPbIniCleanerDlg::CPbIniCleanerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPbIniCleanerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPbIniCleanerDlg)
	m_szPbini = _T("");
	m_bCheckAll = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPbIniCleanerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPbIniCleanerDlg)
	DDX_Control(pDX, IDOK, m_btnOk);
	DDX_Control(pDX, IDC_LIST, m_list);
	DDX_Text(pDX, IDC_PBINI, m_szPbini);
	DDX_Check(pDX, IDC_CHECK_ALL, m_bCheckAll);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPbIniCleanerDlg, CDialog)
	//{{AFX_MSG_MAP(CPbIniCleanerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CHECK_ALL, OnCheckAll)
	ON_NOTIFY(NM_CLICK, IDC_LIST, OnClickList)
	ON_WM_LBUTTONDOWN()
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST, OnItemchangedList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CString GetFileNameOnly( CString &fullPath )
{
	return fullPath.Right(fullPath.GetLength() -
		fullPath.ReverseFind(_T('\\')) - 1);
}
/////////////////////////////////////////////////////////////////////////////
// CPbIniCleanerDlg message handlers
LPCSTR DEFAULT = "<unknown>";

BOOL CPbIniCleanerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_imageList.Create(IDB_BITMAP, 15, 15, RGB(255,255,255));	
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_list.SetImageList(&m_imageList, LVSIL_SMALL);
	//m_list.ModifyStyle(0, LVS_EX_CHECKBOXES, SWP_NOMOVE | SWP_NOSIZE);
	m_list.ModifyStyleEx(0, LVS_EX_CHECKBOXES, SWP_NOMOVE | SWP_NOSIZE);

	m_list.InsertColumn(0, "Application", LVCFMT_LEFT, 130);
	m_list.InsertColumn(1, "Application library path", LVCFMT_LEFT, 310);

	GetDefaultPBIni();

	CWaitCursor wc;
	UINT result;
	int i = 0, libindex = 0;
	PbINILibrary lib;
	bool bFound;

	if(m_szPbini.IsEmpty()) return TRUE;
		
	LPSTR pBuffer = new char[0xffff];
	memset(pBuffer, 0, 0xffff);

	result = GetPrivateProfileString("Application", NULL, DEFAULT, 
		(char*) pBuffer, 0xfffe, m_szPbini);

	if(strcmp(pBuffer, DEFAULT) != 0) {
		while(1) {

			lib.key = (LPSTR) pBuffer + i;
			i += lib.key.GetLength() + 1;

			if(lib.key.IsEmpty())
				break;

			if( lib.key[0] != '$' ) continue;
	
			lib.path = lib.key.Mid(1, lib.key.Find('(') - 1);
			lib.name = GetFileNameOnly(lib.path);
			lib.appname = lib.key.Right(lib.key.GetLength() - lib.key.Find('(') - 1);
			lib.appname = lib.appname.Left(lib.appname.GetLength() - 1);

			bFound = (GetFileAttributes(lib.path) != 0xFFFFFFFF);

			if(bFound) {
				m_list.InsertItem(libindex, lib.appname, 1);
				m_list.SetCheck(libindex, FALSE);
			} else {
				m_list.InsertItem(libindex, lib.appname, 0);
				m_list.SetCheck(libindex, TRUE);

				m_btnOk.EnableWindow();
			}

			m_list.SetItemText(libindex, 1, lib.path);

			libindex++;
			//m_list.InsertItem(libindex++, lib.appname);
//			libindex = m_Libraries.Add(lib);

//			cbindex = m_cbLibs.AddString(lib.path);
//			m_cbLibs.SetItemData(cbindex, libindex);
		}
	}
	delete pBuffer;
	
	UpdateData(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPbIniCleanerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPbIniCleanerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPbIniCleanerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPbIniCleanerDlg::GetDefaultPBIni()
{
	CRegistry registry;

	if(registry.GetEntry(CREGISTRY_MACHINE, "SOFTWARE\\Microsoft\\Windows" \
		"\\CurrentVersion\\App Paths\\pb60.exe\\", m_szPbini))
	{
		m_szPbini = m_szPbini.Left(m_szPbini.GetLength() - 6) + ".ini";

		UpdateData(false);
	} 
	else 
	{
		m_szPbini = "";
	}
}

void CPbIniCleanerDlg::OnCheckAll() 
{
	UpdateData(true);

	int iCount = m_list.GetItemCount();
	for(int i = 0; i < iCount; i++) {
		SetCheck(i, m_bCheckAll);
	}	

	m_btnOk.EnableWindow();
}

void CPbIniCleanerDlg::OnOK() 
{
	LPSTR pBuffer = new char[0xffff];
	memset(pBuffer, 0, 0xffff);

	CString appname;
	for(int i = 0; i < m_list.GetItemCount(); i++) {
		if(!m_list.GetCheck(i)) continue;

		appname.Format("$%s(%s)", m_list.GetItemText(i, 1),
			m_list.GetItemText(i, 0));

		GetPrivateProfileString("Application", appname, DEFAULT, 
			(char*) pBuffer, 0xfffe, m_szPbini);
		
		if(strcmp(pBuffer, DEFAULT) != 0) {
			WritePrivateProfileString("Application", appname, NULL, m_szPbini);

			m_list.DeleteItem(i);
			i--;
		}
	}
	delete pBuffer;

	m_btnOk.EnableWindow(FALSE);
}

void CPbIniCleanerDlg::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	POINT pt;
	GetCursorPos(&pt);

	UINT uiFlag;
	m_list.ScreenToClient(&pt);
	int index = m_list.HitTest(pt, &uiFlag);

	if(uiFlag == LVHT_ONITEMICON) {
		SetCheck(index, m_list.GetCheck(index) ? false : true);
	}
	
	*pResult = 0;
}

void CPbIniCleanerDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDown(nFlags, point);
}

void CPbIniCleanerDlg::SetCheck(int index, BOOL bCheck)
{
	m_list.SetItem(index, 0, LVIF_IMAGE, NULL, bCheck ? 0 : 1,
		0, 0, NULL);
	m_list.SetCheck(index, bCheck);

	UpdateData(false);
	m_btnOk.EnableWindow();
}

void CPbIniCleanerDlg::OnItemchangedList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	*pResult = 0;
}
